#-*- coding:utf-8 -*-

#    Gedit but_active plugin version 3.18.0
#    Copyright © 2011-2013 sasakima-nao <sasakimanao@gmail.com>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    2015.11.08 Version 3.18.0
#    Support Gedit 3.18
#    Add gi.require_version
#
#    2014.11.17 Version 3.12.0
#    Support Gedit 3.12
#
#    2013.11.03 Version 3.1.0
#    Support Gedit 3.8 (Python3)
#    Remove Old Code
#
#    2012.08.23 Version 3.0.1
#    Move Menu : Notebook Popup to Documents Menu
#    ( Missing NotebookPopupMenu )
#    Keyboard ShortCut <Control><Shift><Alt>W
#
#    2011.06.04 Version 3.0.0

import gi
gi.require_version("Gtk", "3.0")
gi.require_version("Gedit", "3.0")
gi.require_version("Peas", "1.0")

from gi.repository import GObject, Gedit, Gtk, Gio

class ButActiveAppActivatable(GObject.Object, Gedit.AppActivatable):
    """
        Set GMenu and Accelerator
    """
    app = GObject.property(type=Gedit.App)
 
    def __init__(self):
        GObject.Object.__init__(self)
 
    def do_activate(self):
        self.app.add_accelerator("<Control><Shift><Alt>W", "win.but_active", None)
        self.menu_ext = self.extend_menu("tools-section")
        item = Gio.MenuItem.new("アクティブ以外全部閉じる",  "win.but_active")
        self.menu_ext.append_menu_item(item)
 
    def do_deactivate(self):
        self.app.remove_accelerator("win.but_active", None)

class ButActive(GObject.Object, Gedit.WindowActivatable):
    __gtype_name__ = "ButActive"
    window = GObject.property(type=Gedit.Window)
    def __init__(self):
        GObject.Object.__init__(self)

    def do_activate(self):
        self.action = Gio.SimpleAction.new("but_active", None)
        self.action.connect('activate', self.on_but_active_activate)
        self.window.add_action(self.action)
        # window のシグナル接続
        self.tab_list = []
        self.id1 = self.window.connect("tab-added", self.on_tab_added)
        self.id2 = self.window.connect("tab-removed", self.on_tab_removed)

    def do_deactivate(self):
        self.window.remove_action("but_active")
        # シグナルの切断を忘れずに
        self.window.disconnect(self.id1)
        self.window.disconnect(self.id2)

    def do_update_state(self):
        self.action.set_enabled(self.window.get_active_document() != None)

    def on_tab_added(self, window, tab):
        self.tab_list.append(tab)

    def on_tab_removed(self, window, tab):
        self.tab_list.remove(tab)

    def on_but_active_activate(self, action, data=None):
        ac = self.window.get_active_tab()
        # removed に左右されるのでコピーしてからループ
        copy_list = self.tab_list[:]
        for tab in copy_list:
            if tab != ac:
                self.window.close_tab(tab)
