#-*- coding:utf-8 -*-

#    Gedit lf_to_br plugin version 3.18.0
#    Copyright © 2011-2013 sasakima-nao <sasakimanao@gmail.com>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    2015.11.08 Version 3.18.0
#    Support Gedit 3.18
#    Add gi.require_version
#
#    2014.11.17 Version 3.12.0
#    Support Gedit 3.12
#    Keyboard ShortCut <Control>B
#
#    2013.11.03 Version 3.1.0
#    Support Gedit 3.8 (Python3)
#    Support CRLF
#    Fix: GtkActionGroup Name
#
#    2011.06.04 Version 3.0.0

import gi
gi.require_version("Gtk", "3.0")
gi.require_version("Gedit", "3.0")
gi.require_version("Peas", "1.0")

from gi.repository import GObject, Gedit, Gtk, Gio

class LF_on_BRAppActivatable(GObject.Object, Gedit.AppActivatable):
    """
        Set GMenu and Accelerator
    """
    app = GObject.property(type=Gedit.App)
 
    def __init__(self):
        GObject.Object.__init__(self)
 
    def do_activate(self):
        self.app.add_accelerator("<Control>B", "win.lf_on_br", None)
        self.menu_ext = self.extend_menu("tools-section")
        item = Gio.MenuItem.new("LF 位置に <br />",  "win.lf_on_br")
        self.menu_ext.append_menu_item(item)
 
    def do_deactivate(self):
        self.app.remove_accelerator("win.lf_on_br", None)

class LF_on_BR(GObject.Object, Gedit.WindowActivatable):
    __gtype_name__ = "LF_on_BR"
    window = GObject.property(type=Gedit.Window)
    def __init__(self):
        GObject.Object.__init__(self)

    def do_activate(self):
        self.action = Gio.SimpleAction.new("lf_on_br", None)
        self.action.connect('activate', self.on_lf_on_br_activate)
        self.window.add_action(self.action)

    def do_deactivate(self):
        self.window.remove_action("lf_on_br")

    def do_update_state(self):
        self.action.set_enabled(self.window.get_active_document() != None)

    def on_lf_on_br_activate(self, action, data=None):
        view = self.window.get_active_view()
        buf = view.get_buffer()
        try:
            begin, end = buf.get_selection_bounds()
        except:
            self.messagebox("変換したいテキストを選択してください")
            return
        text = begin.get_text(end)
        lf = "\n"
        if "\r" in text:
            lf = "\r\n"
        lines = text.split(lf)
        result = []
        for line in lines:
            result.append("{0}<br />".format(line))
        buf.delete_selection(True, True)
        buf.insert_at_cursor(lf.join(result))

    def messagebox(self, text):
        dlg = Gtk.MessageDialog(
                self.window,
                Gtk.DialogFlags.MODAL,
                Gtk.MessageType.WARNING,
                Gtk.ButtonsType.OK,
                text)
        r = dlg.run()
        dlg.destroy()
